//+------------------------------------------------------------------+
//|                                                          TRD.mq4 |
//|                                                          by Raff |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, raff1410@o2.pl"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Red
#property indicator_color3  DarkSlateGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2


//
//
//
//
//

extern int MA_Period = 20;
extern int MA_Method = 0;
extern int MA_Price  = 0;

//
//
//
//
//

double UpH[];
double DnH[];
double Buffer[];
double trend[];
string short_name;
//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   switch(MA_Method)
     {
      case 1 :  short_name="Trend deviation | EMA(";  break;
      case 2 :  short_name="Trend deviation | SMMA("; break;
      case 3 :  short_name="Trend deviation | LWMA("; break;
      default : MA_Method=0;
         short_name="Trend deviation | SMA(";
     }
   
   IndicatorBuffers(4);
   SetIndexBuffer(0,UpH);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH);    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer);
   SetIndexBuffer(3,trend);
   IndicatorShortName(short_name+MA_Period+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| TRD - Trend Deviation                                            |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double ma=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i);
            if (ma!=0)
              Buffer[i]=(Close[i]/ma)-1;
              UpH[i] = EMPTY_VALUE;
              DnH[i] = EMPTY_VALUE;
              trend[i] = trend[i+1];
              if (Buffer[i]>0) trend[i] = 1;
              if (Buffer[i]<0) trend[i] =-1;
              if (trend[i] == 1) UpH[i] = Buffer[i];
              if (trend[i] ==-1) DnH[i] = Buffer[i];
   }
return(0);
}
 	  